import { fetch } from '@whatwg-node/fetch';
import { HTTPMethod } from './types';
export interface GenericSDKOptions {
    endpoint?: string;
    fetchFn?: typeof fetch;
}
export interface GenericRequestParams {
    json?: any;
    formData?: FormData;
    params?: Record<string, string>;
    query?: Record<string, string | string[]>;
    headers?: Record<string, string>;
}
export type GenericSDKMethod = (requestParams?: GenericRequestParams) => Promise<Response>;
export declare class SDKValidationError extends Error implements AggregateError {
    readonly path: string;
    readonly method: HTTPMethod;
    errors: any[];
    response: Response;
    constructor(path: string, method: HTTPMethod, errors: any[], response: Response);
    [Symbol.iterator](): IterableIterator<any>;
}
export declare function createGenericSDK({ endpoint, fetchFn }?: GenericSDKOptions): Record<string, Record<HTTPMethod, GenericSDKMethod>>;
